import xml.etree.ElementTree as ET


class Parser():

    def __init__(self, nmap_xml):
        self.nmap = nmap_xml
        tree = ET.parse(self.nmap)
        self.root = tree.getroot()

    def hosts(self, state=None):
        """ Return a dictionary list IP addresses and hostnames.
        :param state: Filter host by state (up, down) if specified.
        """
        # Get IPs
        host_list = []
        for host in self.root.findall('host'):
            if state:
                if state == host.find('status').get('state'):
                    ip = host.find('address').get('addr')
                else:
                    continue
            else:
                ip = host.find('address').get('addr')

            # Get FQDNs
            name_list = []
            for name in host.iter('hostname'):
                name_list.append(name.get('name'))
            machine = {ip: name_list}
            host_list.append(machine)
        return host_list

    def ports(self, ip, state=None):
        """ Return ports
        :param ip: Address to list ports for.
        :param state: Filter port by state (open, closed, filtered) if
        specified.
        """
        port_list = []
        for host in self.root.findall('host'):
            if ip == host.find('address').get('addr'):
                for port in host.iter('port'):
                    if state:
                        if state == port.find('state').get('state'):
                            port_list.append(port.get('portid'))
                    else:
                        port_list.append(port.get('portid'))
        return port_list
